#!/usr/bin/env python
# -*- coding: utf-8 -*-

##
##    Copyright (C) 2005 manatlan manatlan[at]gmail(dot)com
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published
## by the Free Software Foundation; version 2 only.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##

import os,sys,stat

try:
    import subprocess
except ImportError:
    print "jbrout need python2.4 or +"
    sys.exit()

from tools import OldPhotoCmd,PhotoCmd

def walktree (top = ".", depthfirst = True):
    names = os.listdir(top)
    if not depthfirst:
        yield top, names
    for name in names:
        try:
            st = os.lstat(os.path.join(top, name))
        except os.error:
            continue
        if stat.S_ISDIR(st.st_mode):
            for (newtop, children) in walktree (os.path.join(top, name), depthfirst):
                yield newtop, children
    if depthfirst:
        yield top, names

def convert(file):
    pc1 = OldPhotoCmd(file)
    if pc1.tags:
        # if there are tags : it's an old jbrout format ;-)
        # so we needs to transpose tags and comment to the new format
        pc2 = PhotoCmd(file)
        pc2._setCommentAndTags(pc1.comment,pc1.tags)

        pc3 = PhotoCmd(file)
        if pc3.tags == pc1.tags and pc3.comment == pc1.comment:
            sys.stdout.write("o")
        else:
            sys.stdout.write("X")
            f=open("convert.err.log","a+")
            f.write("|%s|%s|%s|\n" % (file,pc1.comment,str(pc1.tags)))
            f.close()
    else:
        sys.stdout.write(".")
    sys.stdout.flush()


if __name__ == "__main__":
    path ="/media/data/photos"

    list = []
    for (basepath, children) in walktree(path,False):
        for child in children:
            if child[-4:] == ".jpg":
                list.append( os.path.join(basepath, child).decode( sys.getfilesystemencoding() ) )

    print "Will convert ",len(list),"file(s)"
    for file in list:
        convert(file)
